#include <iostream>

extern const int a;
extern const int b;
extern const int c;
extern const int d;

int main() {
  {
    /**
     * Task 1.
     *
     * Написать программу, вычисляющую выражение a * (b + (c / d)) и выводящую результат с плавающей точкой,
     * где a, b, c, d – целочисленные константы. Используйте static_cast
     * или СStyle cast к float чтобы выполнить точное деление.
     */
    const int a = 2;
    const int b = 3;
    const int c = 5;
    const int d = 7;
    float f_result = a * (b + (float(c) / d));
    std::cout << f_result << std::endl;
  }
  {
    /**
     * Task 2.
     *
     * Дано целое число. Если оно меньше или равно 21, то выведите на экран разницу между этим числом
     * и числом 21. Если же заданное число больше, чем 21, необходимо вывести
     * удвоенную разницу между этим числом и 21.
     * При выполнении задания следует использовать тернарный оператор (?:).
     */
    int i_less = 15;
    std::cout << ((i_less <= 21) ? 21 - i_less : 2 * (i_less - 21)) << std::endl;
    int i_more = 31;
    std::cout << ((i_more <= 21) ? 21 - i_more : 2 * (i_more - 21)) << std::endl;
  }

  {
    /**
     * Task 3.
     * Описать трёхмерный целочисленный массив, размером 3х3х3 и указатель на значения внутри массива
     * и при помощи операции разыменования вывести на экран значение центральной ячейки получившегося куба [1][1][1].
     */
    int i_arr[3][3][3];
    for (int i = 0; i < 3; i++) {
      for (int j = 0; j < 3; j++) {
        for (int k = 0; k < 3; k++) {
          i_arr[i][j][k] = 100 * i + 10 * j + k;
        }
      }
    }
    int *ptr = reinterpret_cast<int *>(&i_arr);
    // Указатель находится на первой ячейке 0,0,0.
    // Первая плоскость 3d массива - 9 элементов(-1 в котором мы уже находимся).
    // + 5 элементов до центрального второй плоскости. Итого +13.
    std::cout << *(ptr + 13) << std::endl;
  }

  {
    /**
     * Task 4.
     *
     * Написать программу, вычисляющую выражение из первого задания, а переменные для неё объявлены
     * и инициализировать в другом cpp файле. Используйте extern.
     */
    float f_result = a * (b + (float(c) / d));
    std::cout << f_result << std::endl;
  }

  return 0;
}
